"""
CPX, Compare with X Test
"""

import unittest
from nesasm.tests import MetaInstructionCase


class CpxImmTest(unittest.TestCase, metaclass=MetaInstructionCase):

    asm = 'CPX #$10'
    lex = [('T_INSTRUCTION', 'CPX'), ('T_HEX_NUMBER', '#$10')]
    syn = ['S_IMMEDIATE']
    code = [0xE0, 0x10]


class CpxImmDecimalTest(unittest.TestCase, metaclass=MetaInstructionCase):

    asm = 'CPX #10'
    lex = [('T_INSTRUCTION', 'CPX'), ('T_DECIMAL_NUMBER', '#10')]
    syn = ['S_IMMEDIATE']
    code = [0xE0, 0x0A]


class CpxImmBinaryTest(unittest.TestCase, metaclass=MetaInstructionCase):

    asm = 'CPX #%00000100'
    lex = [('T_INSTRUCTION', 'CPX'), ('T_BINARY_NUMBER', '#%00000100')]
    syn = ['S_IMMEDIATE']
    code = [0xE0, 0x04]


class CpxZpTest(unittest.TestCase, metaclass=MetaInstructionCase):

    asm = 'CPX $00'
    lex = [('T_INSTRUCTION', 'CPX'), ('T_ADDRESS', '$00')]
    syn = ['S_ZEROPAGE']
    code = [0xE4, 0x00]


class CpxAbsTest(unittest.TestCase, metaclass=MetaInstructionCase):

    asm = 'CPX $1234'
    lex = [('T_INSTRUCTION', 'CPX'), ('T_ADDRESS', '$1234')]
    syn = ['S_ABSOLUTE']
    code = [0xEC, 0x34, 0x12]
